> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.emnify.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.emnify.com/_mcp/server.

# List data stream configurations of your organization

GET https://cdn.emnify.net/api/v2/data_stream

Required permissions Beta [Learn more](/developers/api-guidelines/permissions#how-permissions-work)`DataStream` + `List`Roles: Administrator User Observer

Reference: https://docs.emnify.com/developers/api/integrations/list-data-streamer-v-2-s

## Authentication

- `Authorization` header (bearer token, required) — An `auth_token` should be provided to authenticate a session. To obtain an `auth_token`, see the [`/api/v1/authenticate` **POST** request](/developers/api/authentication/authenticate).

## Response

### 200

List of data stream with their current status

- `name` (string, optional) — Descriptive name or purpose of the data stream
- `destination` (ApiV2DataStreamGetResponsesContentApplicationJsonSchemaDestination, optional)
- `filters` (list of ApiV2DataStreamGetResponsesContentApplicationJsonSchemaFiltersItems, optional)
- `data_stream_type` (any, optional)
- `relation_resolution` (any, optional)
- `status` (any, optional)

## Errors

### 400 Bad Request Error

The request is malformed, e.g. the body cannot be parsed

- `any`

### 401 Unauthorized Error

No or invalid authentication token provided

- `any`

### 403 Forbidden Error

Authentication token is valid, but user has no access permissions to the request resource

- `any`

### 404 Not Found Error

A non-existent resource is requested

- `any`

## Types

### ApiV2DataStreamGetResponsesContentApplicationJsonSchemaDestination

- `connection_type` (string, required)
- `format` (string, optional)
- `credentials` (ApiV2DataStreamGetResponsesContentApplicationJsonSchemaDestinationCredentials, optional) — Destination credentials

### ApiV2DataStreamGetResponsesContentApplicationJsonSchemaFiltersItems

- `field` (string, optional) — Field to filter on
- `value` (list of string, optional) — Values to filter on

### ApiV2DataStreamGetResponsesContentApplicationJsonSchemaDestinationCredentials

Destination credentials

### ApiV2DataStreamGetResponsesContentApplicationJsonSchemaDestinationCredentials0

Credential fields for Amazon Kinesis Data Streams

- `region` (string, required) — AWS Region of your Kinesis Data Stream
- `stream_name` (string, required) — Name of your Kinesis Data Stream
- `role_arn` (string, required) — Role ARN of IAM role with write permission for your Kinesis Stream

### ApiV2DataStreamGetResponsesContentApplicationJsonSchemaDestinationCredentials1

Credential fields for Amazon S3

- `region` (string, required) — AWS Region of your Kinesis Data Stream
- `bucket_name` (string, required) — Name of your S3 bucket
- `role_arn` (string, required) — Role ARN of IAM role with write permission for your S3 bucket
- `flush_size` (integer, optional) — Maximal number of entries in a single file. Default is `10000`. Valid flush sizes are between 10 and 100000.
- `rotate_interval` (integer, optional) — Maximal time in milliseconds between file writes. Default is `10000` ms. Valid rotation intervals are between 10000 ms and 900000 ms.

### ApiV2DataStreamGetResponsesContentApplicationJsonSchemaDestinationCredentials2

Credential fields for Webhook

- `url` (string, required) — URL of your Webhook / RestAPI endpoint
- `method` (string, optional) — HTTP Method to use. Options are `POST` (default), `PUT` and `PATCH`
- `headers` (list of string, optional) — Array containing additional header tuples. Expected Format is `["header1:value1, "header2:value2", ...]`. Headers are masked in GET request.
- `size` (integer, optional) — Number specifying of request should contain `1` message or an array of messages of the specified batch size. Default is `3000`. Valid sizes are between 1 and 10000.

### ApiV2DataStreamGetResponsesContentApplicationJsonSchemaDestinationCredentials3

Credential fields for KeenIO

- `project_id` (string, required) — Project ID reported by KeenIO
- `write_key` (string, required) — Write key of your KeenIO Project.
- `collection_name` (string, required) — Collection Name that you want to stream your data to.
- `size` (integer, optional) — Number specifying of request should contain `1` message or an array of messages of the specified batch size. Default is `3000`. Valid sizes are between 1 and 10000.

### ApiV2DataStreamGetResponsesContentApplicationJsonSchemaDestinationCredentials4

Credential fields for Datadog

- `api_key` (string, required) — Datadog API Key
- `region` (string, optional) — Datadog region. Options are `US` (default), `US3`, `EU` and `US1FED`

### ApiV2DataStreamGetResponsesContentApplicationJsonSchemaDestinationCredentials5

Credential fields for Microsoft Azure EventHub

- `connection_string` (string, required) — Connection string with Access Key to your Event Hub.

### ApiV2DataStreamGetResponsesContentApplicationJsonSchemaDestinationCredentials6

Credential fields for Google Cloud Pub/Sub

- `cps_topic` (string, required) — Topic name of PubSub topic
- `cps_project` (string, required) — Project ID of the topic project.

## Examples

**Response**

```json
{
  "0": {
    "data_stream_type": {
      "description": "Usage",
      "id": 1
    },
    "destination": {
      "connection_type": "AwsKinesis",
      "credentials": {
        "region": "eu-west-1",
        "role_arn": "arn:aws:iam::123456789012:role/my-data-stream",
        "stream_name": "my-data-stream"
      },
      "format": "Json"
    },
    "filters": [],
    "id": "689d97ba",
    "relation_resolution": {
      "description": "Both",
      "id": "3,"
    },
    "status": {
      "description": "Running",
      "id": "1,"
    }
  },
  "1": {
    "data_stream_type": {
      "description": "Usage",
      "id": 1
    },
    "destination": {
      "connection_type": "RestAPI",
      "credentials": {
        "size": 3000,
        "url": "https://example.com"
      },
      "format": "Json"
    },
    "filters": [],
    "id": "123bc456",
    "relation_resolution": {
      "description": "Own",
      "id": "1,"
    },
    "status": {
      "description": "Paused",
      "id": "2,"
    }
  }
}
```

**SDK Code**

```python List Data Streams
import requests

url = "https://cdn.emnify.net/api/v2/data_stream"

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers)

print(response.json())
```

```javascript List Data Streams
const url = 'https://cdn.emnify.net/api/v2/data_stream';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go List Data Streams
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://cdn.emnify.net/api/v2/data_stream"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby List Data Streams
require 'uri'
require 'net/http'

url = URI("https://cdn.emnify.net/api/v2/data_stream")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java List Data Streams
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://cdn.emnify.net/api/v2/data_stream")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php List Data Streams
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://cdn.emnify.net/api/v2/data_stream', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp List Data Streams
using RestSharp;

var client = new RestClient("https://cdn.emnify.net/api/v2/data_stream");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift List Data Streams
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://cdn.emnify.net/api/v2/data_stream")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```